package me.eater.hefbrug.dsl.context

import me.eater.hefbrug.dsl.annotation.HefbrugDSL
import me.eater.hefbrug.dsl.context.extension_util.RuntimeRegister
import me.eater.hefbrug.dsl.scope.AbstractScope
import me.eater.hefbrug.dsl.scope.RootScope
import me.eater.hefbrug.dsl.scope.SelectorScope
import java.util.*

@HefbrugDSL
class CollectionContext(override val runtimeUUID: UUID, private val parentScope: SelectorScope, private val rootScope: RootScope) :
    TargetedContext() {

    override val contextUUID: UUID
        get() = parentScope.contextUUID

    init {
        RuntimeRegister[runtimeUUID].registerScope(this, AbstractScope(rootScope))
    }
}