package me.eater.hefbrug.executor

import me.eater.hefbrug.dsl.context.SourceContext
import kotlin.script.experimental.api.*
import kotlin.script.experimental.jvm.dependenciesFromCurrentContext
import kotlin.script.experimental.jvm.jvm

class HefbrugCompilationConfiguration : ScriptCompilationConfiguration({
    defaultImports(
        listOf(
            // Default kotlin imports
            "kotlin.*",
            "kotlin.annotations.*",
            "kotlin.collections.*",
            "kotlin.comparisons.*",
            "kotlin.io.*",
            "kotlin.ranges.*",
            "kotlin.sequences.*",
            "kotlin.text.*",
            "kotlin.jvm.*",
            "java.lang.*",


            // Own imports
            "me.eater.hefbrug.dsl.context.utils.*",
            "me.eater.hefbrug.state.ExistenceStatus.*",
            "me.eater.hefbrug.dsl.annotation.include"
        )
    )
    displayName("Hefbrug definition script")
    baseClass(HefbrugScript::class)
    implicitReceivers(SourceContext::class)


    jvm {
        dependenciesFromCurrentContext(wholeClasspath = true)
    }

    ide {
        acceptedLocations(
            ScriptAcceptedLocation.Everywhere,
            ScriptAcceptedLocation.Project,
            ScriptAcceptedLocation.Sources
        )
    }
})