package me.eater.hefbrug.logging

import org.apache.logging.log4j.Level
import org.apache.logging.log4j.Marker
import org.apache.logging.log4j.kotlin.Logging
import org.apache.logging.log4j.message.EntryMessage
import org.apache.logging.log4j.message.Message

@Suppress("UNUSED")
interface Logging : Logging {
    fun log(level: Level, marker: Marker, msg: Message) = logger.log(level, marker, msg)
    fun log(level: Level, marker: Marker, msg: Message, t: Throwable?) = logger.log(level, marker, msg, t)
    fun log(level: Level, marker: Marker, msg: CharSequence) = logger.log(level, marker, msg)
    fun log(level: Level, marker: Marker, msg: CharSequence, t: Throwable?) = logger.log(level, marker, msg, t)
    fun log(level: Level, marker: Marker, msg: Any) = logger.log(level, marker, msg)
    fun log(level: Level, marker: Marker, msg: Any, t: Throwable?) = logger.log(level, marker, msg, t)
    fun log(level: Level, msg: Message) = logger.log(level, msg)
    fun log(level: Level, msg: Message, t: Throwable?) = logger.log(level, msg, t)
    fun log(level: Level, msg: CharSequence) = logger.log(level, msg)
    fun log(level: Level, msg: CharSequence, t: Throwable?) = logger.log(level, msg, t)
    fun log(level: Level, msg: Any) = logger.log(level, msg)
    fun log(level: Level, msg: Any, t: Throwable?) = logger.log(level, msg, t)
    fun log(level: Level, supplier: () -> Any?) = logger.log(level, supplier)
    fun log(level: Level, t: Throwable, supplier: () -> Any?) = logger.log(level, t, supplier)
    fun log(level: Level, marker: Marker, supplier: () -> Any?) = logger.log(level, marker, supplier)
    fun log(level: Level, marker: Marker, t: Throwable?, supplier: () -> Any?) = logger.log(level, marker, t, supplier)
    fun trace(marker: Marker, msg: Message) = logger.trace(marker, msg)
    fun trace(marker: Marker, msg: Message, t: Throwable?) = logger.trace(marker, msg, t)
    fun trace(marker: Marker, msg: CharSequence) = logger.trace(marker, msg)
    fun trace(marker: Marker, msg: CharSequence, t: Throwable?) = logger.trace(marker, msg, t)
    fun trace(marker: Marker, msg: Any) = logger.trace(marker, msg)
    fun trace(marker: Marker, msg: Any, t: Throwable?) = logger.trace(marker, msg, t)
    fun trace(msg: Message) = logger.trace(msg)
    fun trace(msg: CharSequence) = logger.trace(msg)
    fun trace(msg: Any) = logger.trace(msg)
    fun trace(supplier: () -> Any?) = logger.trace(supplier)
    fun trace(marker: Marker, supplier: () -> Any?) = logger.trace(marker, supplier)
    fun trace(marker: Marker, t: Throwable?, supplier: () -> Any?) = logger.trace(marker, t, supplier)
    fun traceEntry(msg: CharSequence) = logger.traceEntry(msg)
    fun traceEntry(supplier: () -> CharSequence) = logger.traceEntry(supplier)
    fun traceEntry(vararg paramSuppliers: () -> Any?) = logger.traceEntry(*paramSuppliers)
    fun traceEntry(vararg params: Any?) = logger.traceEntry(*params)
    fun traceEntry(message: Message) = logger.traceEntry(message)
    fun <R : Any?> runInTrace(block: () -> R): R = logger.runInTrace(block)
    fun <R : Any?> runInTrace(entryMessage: EntryMessage, block: () -> R): R = logger.runInTrace(entryMessage, block)
    fun debug(marker: Marker, msg: Message) = logger.debug(marker, msg)
    fun debug(marker: Marker, msg: Message, t: Throwable?) = logger.debug(marker, msg, t)
    fun debug(marker: Marker, msg: CharSequence) = logger.debug(marker, msg)
    fun debug(marker: Marker, msg: CharSequence, t: Throwable?) = logger.debug(marker, msg, t)
    fun debug(marker: Marker, msg: Any) = logger.debug(marker, msg)
    fun debug(marker: Marker, msg: Any, t: Throwable?) = logger.debug(marker, msg, t)
    fun debug(msg: Message) = logger.debug(msg)
    fun debug(msg: CharSequence) = logger.debug(msg)
    fun debug(msg: Any) = logger.debug(msg)
    fun debug(supplier: () -> Any?) = logger.debug(supplier)
    fun debug(marker: Marker, supplier: () -> Any?) = logger.debug(marker, supplier)
    fun debug(marker: Marker, t: Throwable?, supplier: () -> Any?) = logger.debug(marker, t, supplier)
    fun info(marker: Marker, msg: Message) = logger.info(marker, msg)
    fun info(marker: Marker, msg: Message, t: Throwable?) = logger.info(marker, msg, t)
    fun info(marker: Marker, msg: CharSequence) = logger.info(marker, msg)
    fun info(marker: Marker, msg: CharSequence, t: Throwable?) = logger.info(marker, msg, t)
    fun info(marker: Marker, msg: Any) = logger.info(marker, msg)
    fun info(marker: Marker, msg: Any, t: Throwable?) = logger.info(marker, msg, t)
    fun info(msg: Message) = logger.info(msg)
    fun info(msg: CharSequence) = logger.info(msg)
    fun info(msg: Any) = logger.info(msg)
    fun info(supplier: () -> Any?) = logger.info(supplier)
    fun info(marker: Marker, supplier: () -> Any?) = logger.info(marker, supplier)
    fun info(marker: Marker, t: Throwable?, supplier: () -> Any?) = logger.info(marker, t, supplier)
    fun warn(marker: Marker, msg: Message) = logger.warn(marker, msg)
    fun warn(marker: Marker, msg: Message, t: Throwable?) = logger.warn(marker, msg, t)
    fun warn(marker: Marker, msg: CharSequence) = logger.warn(marker, msg)
    fun warn(marker: Marker, msg: CharSequence, t: Throwable?) = logger.warn(marker, msg, t)
    fun warn(marker: Marker, msg: Any) = logger.warn(marker, msg)
    fun warn(marker: Marker, msg: Any, t: Throwable?) = logger.warn(marker, msg, t)
    fun warn(msg: Message) = logger.warn(msg)
    fun warn(msg: CharSequence) = logger.warn(msg)
    fun warn(msg: Any) = logger.warn(msg)
    fun warn(supplier: () -> Any?) = logger.warn(supplier)
    fun warn(marker: Marker, supplier: () -> Any?) = logger.warn(marker, supplier)
    fun warn(marker: Marker, t: Throwable?, supplier: () -> Any?) = logger.warn(marker, t, supplier)
    fun error(marker: Marker, msg: Message) = logger.error(marker, msg)
    fun error(marker: Marker, msg: Message, t: Throwable?) = logger.error(marker, msg, t)
    fun error(marker: Marker, msg: CharSequence) = logger.error(marker, msg)
    fun error(marker: Marker, msg: CharSequence, t: Throwable?) = logger.error(marker, msg, t)
    fun error(marker: Marker, msg: Any) = logger.error(marker, msg)
    fun error(marker: Marker, msg: Any, t: Throwable?) = logger.error(marker, msg, t)
    fun error(msg: Message) = logger.error(msg)
    fun error(msg: CharSequence) = logger.error(msg)
    fun error(msg: Any) = logger.error(msg)
    fun error(supplier: () -> Any?) = logger.error(supplier)
    fun error(marker: Marker, supplier: () -> Any?) = logger.error(marker, supplier)
    fun error(marker: Marker, t: Throwable?, supplier: () -> Any?) = logger.error(marker, t, supplier)
    fun fatal(marker: Marker, msg: Message) = logger.fatal(marker, msg)
    fun fatal(marker: Marker, msg: Message, t: Throwable?) = logger.fatal(marker, msg, t)
    fun fatal(marker: Marker, msg: CharSequence) = logger.fatal(marker, msg)
    fun fatal(marker: Marker, msg: CharSequence, t: Throwable?) = logger.fatal(marker, msg, t)
    fun fatal(marker: Marker, msg: Any) = logger.fatal(marker, msg)
    fun fatal(marker: Marker, msg: Any, t: Throwable?) = logger.fatal(marker, msg, t)
    fun fatal(msg: Message) = logger.fatal(msg)
    fun fatal(msg: CharSequence) = logger.fatal(msg)
    fun fatal(msg: Any) = logger.fatal(msg)
    fun fatal(supplier: () -> Any?) = logger.fatal(supplier)
    fun fatal(marker: Marker, supplier: () -> Any?) = logger.fatal(marker, supplier)
    fun fatal(marker: Marker, t: Throwable?, supplier: () -> Any?) = logger.fatal(marker, t, supplier)
}