package me.eater.hefbrug.state.property

import me.eater.hefbrug.state.AbstractState
import kotlin.properties.ReadWriteProperty

class ExtendedPropertyDelegate<T>(
    default: () -> T?,
    required: Boolean,
    writeOnce: Boolean,
    private val isEqual: DiffScope<T>.() -> Boolean
) :
    PropertyDelegate<T>(default, required, writeOnce),
    ReadWriteProperty<AbstractState, T> {

    @Suppress("UNCHECKED_CAST")
    fun hasChanged(other: ExtendedPropertyDelegate<*>): Boolean = !isEqual(DiffScope(this.get(), other.get() as T))


    data class DiffScope<T>(val left: T, val right: T)
}
